Page MenuHomePhabricator

Add "Developers" link to footer of Wikimedia wikis using WikimediaMessages extension
Closed, ResolvedPublic

Description

The current footer links at https://en.wikipedia.org/ look like:

Contact us
Privacy policy About Wikipedia Disclaimers Mobile view

A link reading "Developers" or "API" should be added that links to a developer hub either on MediaWiki.org or on Meta-Wiki.

This is (very) common practice on other websites where the project is seeking outside development efforts. For example, a "Developers" or "API" link can be found on the bottom of Twitter.com, Facebook.com, Wordnik.com, etc.


Version: unspecified
Severity: enhancement
URL: https://www.mediawiki.org/wiki/Requests_for_comment/Add_developer_link_to_footer_of_Wikimedia_wikis

Details

Reference
bz33464

Event Timeline

bzimport raised the priority of this task from to High.Nov 22 2014, 12:05 AM
bzimport set Reference to bz33464.
bzimport added a subscriber: Unknown Object (MLST).
MZMcBride created this task.Jan 2 2012, 4:03 AM

There's a Powered by MediaWiki button already.

(In reply to comment #1)

There's a Powered by MediaWiki button already.

Yes, that's true. I'm not sure how that's relevant here, though. "Powered by MediaWiki" shows users what software is being run and gives a little publicity/promotion to the wiki software.

In this bug, we're talking about a link to a developer or API portal/help page/something where end users can get involved with the data from the project they're viewing. That's a substantial difference in purpose, in my view.

I'd agree with Max on this one. When I see "powered by N" I go "oh, okay. It's powered by something. That's nice." My instant assumption is not that I can get involved in that something - quite the opposite. I'll leave it to Brandon et al to comment on the design aspect and whatnot.

Jorm added a comment.Sep 18 2012, 12:23 AM

I also agree with Max (shudder).

Link should come after "Mobile view" and be named something like "Developer Central" or "Developer Hub" (since the other links are nouns and not actions, this must be a noun, too).

This should then point [[mw:Project:Help]], which is the "Community Portal". Note that page suffers from being horrid looking; someone should clean it up. I'd think this falls into Sumana's camp, since it's about volunteer developer relations.

I would much rather it went to a new page, dedicated for this exact purpose. Project:Help is intended to be help about using/working on the MW site, and I can see that once this is implemented there will be feature creep which will move it away from its original purpose.

[Side note: the Project namespace is, like on all wikis, used for meta-discussions related to the operation and development of the wiki. Unfortunately, in the context of 'the MediaWiki project' this name is confusing. I long ago suggested that it be renamed to 'Site' to avoid this issue, but Brion vetoed it. See bug 7778 for details - note, it's still not too late to make this change as all the old links will continue to work.]

One of the hubs might be appropriate - probably [[mw:Developer hub]] (but there is also [[mw:User hub]] and [[mw:Sysadmin hub]] - all of which need some tlc) - but perhaps we need a new more-tightly-focussed page that spans user-types.

Personally, I would recommend that we create [[mw:Get involved]] if it is about general MW involvement, or perhaps [[meta:Developer hub]], with links to mw.org, if it's more WMF focussed (or has that all moved to mw.org now - I am not so clear about the distinction between these two sites as I used to be).

Note - I've just seen that [[meta:Developer hub]] already exists. It's not quite what we're after at the moment, but it looks like a sensible destination.

Important note: whatever the destination page, it must be translatable via the Translate extension before it gets enabled.

HappyDog is right about Project:, the equivalent of Project:Help is [[mw:Help:Contents]] or the more useful [[mw:Manual:Contents]]. The latter or [[mw:Developer hub]] would already be ok enough for this request, except that they contain a bit too much; if it's hard to find things in those pages, fix them.

If this is about getting contributions to MediaWiki, this is indeed Sumana's realm and [[mw:How to become a MediaWiki hacker]] is perfect.
If it's more an API-style link, we don't need a new page, we just need a line on the API page saying that if not stated otherwise keys are not needed; and a new small section on this page will suffice to do both.

Creating yet another page, and on Meta, seems a bad idea. It would be useful only if we extend the purposes of the page a lot, to include links to:

  • [[m:Research:Index]] (for researchers; but probably not the best place)
  • [[m:Wikimedia update feed service]] (up to date? I suppose search engines already know)
  • [[m:Data dumps]] (maybe; don't people know already?)
  • ...
Qgil added a comment.Sep 18 2012, 4:22 PM

Interesting idea. Can we agree first on who do we want to attract to do what? Depending on the answer the destination page might be very different.

The examples provided by MZMcBride refer to app developers willing to use the API:

It's the most common use case out there and it could be well represented with a rather standard "Developers" link after "Mobile View".

The most appropriate destination for this link seems to be http://www.mediawiki.org/wiki/API:Main_page - a page that could be fine tuned and has the additional advantage of being already translated to several languages.

Other potential audiences could be

  • Technical contributors to Wikipedia and other Wikimedia projects.
  • Contributors to Mediawiki and related projects.

But I'd keep a clean call for app developers from the Wikipedia template, without forcing them to dive deep into open source contributions and the many ways for extending and hacking MediaWiki. For that there is the "Powered by Mediawiki" banner, and we can always promote those alternatives from the API page itself.

Based on an idea by Tomasz, I have submitted https://gerrit.wikimedia.org/r/24419 which set up a http://developer.wikimedia.org/ virtual host pointing to http://www.mediawiki.org/wiki/Developer_hub

(In reply to comment #8)

Interesting idea. Can we agree first on who do we want to attract to do what?
Depending on the answer the destination page might be very different.

I think we want to attract developers of all kinds. I've posted more of my thoughts to wikitech-l (http://lists.wikimedia.org/pipermail/wikitech-l/2012-September/063361.html) and I've started an RFC here: https://www.mediawiki.org/wiki/Requests_for_comment/Add_developer_link_to_footer_of_Wikimedia_wikis.

Qgil added a comment.Dec 24 2012, 5:23 PM

There are many tech tasks to get involved at mediawiki.org & Wikimedia tech beyond software development as in coding.

What about a link "Developers" after "Mobile view" and pointing to
https://www.mediawiki.org/wiki/How_to_contribute

That page needs some more love, but is already probably our best common starting point for all tech audiences.

"Developers" is not a perfect lable but is the less misleading single word I could come up with. It is better than "Developer" in the sense that shows a community behind.

"OSS contributors" would be more precise but I'm not sure "OSS" is identified by many? Although actual OSS contributors tend to know that they are "OSS contributors", so perhaps there is a point?

Better ideas welcome.

Qgil added a comment.Dec 28 2012, 11:10 PM

There have been plenty of edits done to https://www.mediawiki.org/wiki/How_to_contribute during this week. Your feedback is welcome.

See http://www.mediawiki.org/wiki/Talk:How_to_contribute#Cluttered_page_21762 to have an idea of where I plan to go. Your feedback and help is welcome.

I think this is now clearly the page we want to link at the footer of Wikimedia sites. It still needs a bit of love and polishing but we are getting there.

(In reply to comment #12)

https://www.mediawiki.org/wiki/How_to_contribute

I think this is now clearly the page we want to link at the footer of
Wikimedia sites.

Now? No. Maybe in a few weeks after the landing pages are separated out. Maybe. What you're working on looks interesting, but I'm still not quite sure it's related to this bug.

The current draft of https://www.mediawiki.org/wiki/How_to_contribute seems to miss what I consider a huge component to resolving this bug: providing information about how to take data from Wikimedia wikis and use it in your own application. This is currently confined to a single sentence in your draft, but I think it should be an entire branch.

Qgil added a comment.Dec 29 2012, 7:01 AM

(In reply to comment #13)

Now? No. Maybe in a few weeks after the landing pages are separated out.
Maybe.
What you're working on looks interesting, but I'm still not quite sure it's
related to this bug.

Yes, you are right. What I meant with my poor wording is that now https://www.mediawiki.org/wiki/How_to_contribute is clearly the best candidate to become the destination link. At least this is what I'm proposing, in order to move forward, focus our attention improving that page and the immediately related and forget about the other alternative.

The current draft of https://www.mediawiki.org/wiki/How_to_contribute seems
to miss what I consider a huge component to resolving this bug: providing
information about how to take data from Wikimedia wikis and use it in your
own
application. This is currently confined to a single sentence in your draft,
but
I think it should be an entire branch.

Good suggestion and I will work on this next week.

Qgil added a comment.Dec 31 2012, 11:59 PM

Check https://www.mediawiki.org/wiki/How_to_contribute with your change suggested and more.

(In reply to comment #15)

Check https://www.mediawiki.org/wiki/How_to_contribute with your change
suggested and more.

Old: https://www.mediawiki.org/w/index.php?title=How_to_contribute&oldid=622148
Current: https://www.mediawiki.org/w/index.php?title=How_to_contribute&oldid=622756

That looks significantly better. Nice work. :-) This is headed in a good direction, I think.

I'll leave some comments at https://www.mediawiki.org/wiki/Talk:How_to_contribute.

Status update on this?

Qgil added a comment.Apr 2 2013, 9:24 PM

I believe we have fulfilled all the requirements for a landing page from Wikimedia footers to https://www.mediawiki.org/wiki/How_to_contribute

If there is something you still miss in that page could you please simply edit it?

(In reply to comment #18)

I believe we have fulfilled all the requirements for a landing page from
Wikimedia footers to https://www.mediawiki.org/wiki/How_to_contribute

If there is something you still miss in that page could you please simply
edit it?

Looks good to me. Thank you for your work on this. :-)

Okay, so I believe this would get added to [[mw:Extension:WikimediaMessages]].

Are we agreed that this should read "Developers" and should go in the footer after the "Mobile view" link?

If we're not agreed, we'll need further discussion at [[mw:Requests for comment/Add developer link to footer of Wikimedia wikis]].

If we are agreed, this just needs an easy patch for the extension and then we'll need to wait a week or two for the localization process. (We might not even need to really wait, the deployment process itself takes a few weeks. This can probably just go in to 1.22wmf2.)

Qgil added a comment.Apr 3 2013, 5:39 AM

I'm fine with "Developers", yes.

(In reply to comment #20)

I'm fine with "Developers", yes.

Okay, I've updated the bug summary accordingly.

There seems to be a larger question about whether this "How to contribute" page is on the appropriate wiki, though. Should it be on mediawiki.org, wikitech.wikimedia.org, or meta.wikimedia.org? This shouldn't stop activity on this bug, but that question does need to be resolved at some point.

Qgil added a comment.Apr 3 2013, 4:52 PM

Today the best URL is https://www.mediawiki.org/wiki/How_to_contribute

If/when we have a better URL then we can just update WikimediaMessages accordingly.

Qgil added a comment.Apr 8 2013, 6:03 AM

Actually, perhaps it's not that simple. The URL above works for English, but what about the other languages?

Should we rely on https://www.mediawiki.org/wiki/Special:MyLanguage/How_to_contribute ?

Taking the same language code than the existing project /de /es... works only when we have a version in the same language, otherwise users get the "There is currently no text in this page. You can..." message.

See

https://www.mediawiki.org/wiki/How_to_contribute/fr

vs

https://www.mediawiki.org/wiki/How_to_contribute/zu

(In reply to comment #23)

Should we rely on
https://www.mediawiki.org/wiki/Special:MyLanguage/How_to_contribute ?

Yes, this is obvious. :)

Qgil added a comment.Apr 8 2013, 6:21 AM

Well, considering that most users are anonymous the version they will get with that URL is the English one. If this is obvious to everybody, then fine.

If there is a way to send anonymous readers of certain languages to the available translation of How to contribute, then even better. But we can start with https://www.mediawiki.org/wiki/Special:MyLanguage/How_to_contribute without further delays and leave the door open to a better implementation for the majority of non-English readers that will probably click that link.

Isarra added a comment.Apr 8 2013, 6:55 AM

There are many language projects. If someone comes from the english wikipedia, then it's not unreasonable that they'd wind up on an english landing page, whereas if they come from the portuguese wikisource they'd get portuguese.

The places where that could be an issue are ones like commons serving multiple languages with english as default, but if an anonymous user there is using a different language without logging in chances are they're already used to toggling the templates and such and could do the same on a multilingual landing anyway.

So to clarify, are we putting this on all mediawiki installs, or just wmf ones. I'm less sure this makes sense for third party wikis. (If it's just wmf, extension would make more sense...)

For this bug, let's please focus on Wikimedia wikis. A change to MediaWiki may make sense, but that would be outside this bug's scope.

Something similar to $wmgUseFooterContactLink in https://noc.wikimedia.org/conf/CommonSettings.php.txt is probably what we want here. Or a change to [[mw:Extension:WikimediaMessages]], as discussed above.

Gerrit changeset 67615 seems headed in a direction that we don't want to go in for this bug.

Qgil added a comment.Jun 12 2013, 8:26 PM

I agree that this is a problem/feature very specific to our setup here at Wikimedia.

Qgil added a comment.Jul 12 2013, 5:47 PM

This bug is marked "easy" but it is not that evident for those of us not familiar with the unique Wikimedia infrastructure.

Let's clarify how this needs to be implemented:

Is it really the WikimediaMessages extension what needs to be modified to include the "Developers" string for the footer of Wikimedia sites? In WikimediaMessages.i18n.php at https://git.wikimedia.org/tree/mediawiki%2Fextensions%2FWikimediaMessages ?

Then, where do you instruct every footer of a Wikimedia site to include that string localized next to "Mobile view", pointing to https://www.mediawiki.org/wiki/Special:MyLanguage/How_to_contribute ?

Change 77557 had a related patch set uploaded by MZMcBride:
Add "Developers" link to footer of Wikimedia wikis

https://gerrit.wikimedia.org/r/77557

Change 77557 merged by jenkins-bot:
Add "Developers" link to footer of Wikimedia wikis

https://gerrit.wikimedia.org/r/77557

ori added a comment.Aug 15 2013, 9:57 PM

Patch merged and deployed to 1.22wmf13 wikis. Thanks for seeing this through!

Qgil added a comment.Aug 27 2013, 2:50 PM

Developers link is visible in ALL WIKIMEDIA PROJECTS.

Thank you very much MZMcBride, Matmarex, MaxSem, Nemo, Ori and anyone else involved!

Change 67615 abandoned by Qgil:
Added 'Developers' link to footer link

Reason:
Testing "Abandon change".

https://gerrit.wikimedia.org/r/67615

Restricted Application added a subscriber: TerraCodes. · View Herald TranscriptNov 27 2017, 9:51 PM